<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 12.09.01 - Build 21.09.2012
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module update "\t\tPrüft online, ob eine neue WADE-Version vorhanden ist\n"
$DA->KonsolenAusgabe('Beginne Suche nach Aktualisierungen',1);
$socket_optionen = array(
	'http'=>array(
		'protocol_version'=>1.1,
		'method'=>'GET',
		'header'=>"User-Agent: Wetter-Analyse in Dekaden/".WADE_VERSION_STRING." (http://taw-wade.kilu.de/)\r\n",
		)
);
	if ( $einstellungen['proxy']['http_benutzen'] && strlen($einstellungen['proxy']['http_hostname']) > 7 ){
	$socket_optionen['http']['proxy'] = 'tcp://'.$einstellungen['proxy']['http_hostname'];
	$socket_optionen['http']['request_fulluri'] = $einstellungen['proxy']['volle_uri_senden'];
	}

$DA->KonsolenAusgabe('Frage den HTTP-Server nach XML-Datei mit Update-Informationen...',2);
$context = stream_context_create($socket_optionen);
$daten = file_get_contents('http://taw-wade.kilu.de/update.xml',false,$context);
$header = implode("\r\n",$http_response_header);
$DA->KonsolenAusgabe(print_r($header,true),3);

	if ( strlen($daten) > 128 && strpos($daten,'<wade_update_information>') ){
	$DA->KonsolenAusgabe('Datei gefunden. Prüfe nun die Einträge...',2);
	$neue_version = strpos($daten,'<v1_newest_string>');
		if ( $neue_version > 0 ){
		$neue_version = substr($daten,$neue_version+18,strpos($daten,'</v1_newest_string>')-$neue_version-18);
		$DA->KonsolenAusgabe('Die Version "'.$neue_version.'" wird als die neueste gemeldet',2);
		}
		else{
		$neue_version = WADE_VERSION_STRING;
		$DA->KonsolenAusgabe('Es gibt keinen gültigen Versionseintrag...',2);
		}

		if ( version_compare($neue_version,WADE_VERSION_STRING,'>') ){
		$DA->KonsolenAusgabe('Neue WADE-Version auf dem HTTP-Server gefunden',0);
		// Herunterladen und automatisches Entpacken ggf. später einbauen :)
		}
		else
		$DA->KonsolenAusgabe('Es gibt keine neue WADE-Version',0);

	}
	else
	$DA->KonsolenAusgabe('Konnte keine Verbindung zum HTTP-Server aufbauen',2);

$DA->KonsolenAusgabe('Suche abgeschlossen',1);
?>
